function [ c, Z ] = find_normalization_constant( W, eps_search, c_lower )

    n = size(W, 1);
    I = eye(n);
    if (c_lower == 0)
        c_lower = -sqrt(n);
    end
    
    c_upper = min(eig(W));
    
    while (c_upper - c_lower > eps_search)
        c_mid = 0.5 * (c_upper + c_lower);
        Z = W - I * c_mid;
        Z = inv(Z);
        if (trace(Z*Z) > 1)
            c_upper = c_mid;
        else
            c_lower = c_mid;
        end
    end
    
    c = c_mid;

end

