function [ C ] = greedy( X, k, objtype, verbose_step )
% Greedy removal algorithm.
% see fedorov.m for explanation of arguments

    if (nargin < 4)
        verbose_step = 1;
    end
    
    n = size(X, 1);
    A = X'*X;
    invA = inv(A);
    logdetA = logdet(A, 'chol');
    cov0 = A / n;
    
    C = greedy_c(objtype, X', k, A, invA, logdetA, cov0, verbose_step);

end
